var Backbone = require('backbone') , Handlebars = require('handlebars.runtime')

module.exports = Backbone.View.extend({
  close: function() {
    this.unbind()
    this.$el.unbind()
    if (this.onClose) {
      this.onClose()
    }
  },
  initialize: function() {
    var that = this
    that.events = { 'click a': 'transition' }

    Backbone.trigger('closeView')
    that.listenTo(Backbone, 'closeView', that.close)
  },
  render: function() {
    var ns = 'template'
    var template = Handlebars.template(require(ns + '/' + this.template))
    var content = template(this.data)

    if (!this.$el.html != content) {
      this.$el.html(content)
    }
  },
  transition: function(e) {
    var route = Backbone.$(e.currentTarget).attr('href')

    if (route[0] == '/') {
      route = route.slice(1, route.length)
    }
  
    Backbone.trigger('transition', route, { trigger: true })
    return false
  }
})
