var async = require('async')
  , fs = require('fs')
  , path = require('path')

var Backbone = require('backbone')
  , Handlebars = require('handlebars')
  , Lilo = require('../lilo')

Backbone.$ = function() {
  return {
    attr: function() {}
  }
}

module.exports = Backbone.View.extend({
  initialize: function() {
    var that = this
    that.events = null
  },
  render: function(callback) {
    var that = this;

    async.auto({
      template: function(subCallback) {
        fs.readFile(
          path.join(
            Lilo.View.config.templatePath,
            that.template + '.handlebars'
          ),
          'ascii',
          subCallback
        )
      },
      layout: ['template', function(subCallback, results) {
        if (Lilo.View.config.layout != null) {
          fs.readFile(
            path.join(
              Lilo.View.config.layoutPath,
              Lilo.View.config.layout + '.handlebars'
            ),
            'ascii',
            subCallback
          )
        } else {
          subCallback(null, null)
        }
      }],
    },
    function(err, results) {
      if (err) {
        throw new Error(err.message)
        return callback(err)
      }

      var template = Handlebars.compile(results.template)

      if (results.layout === null) {
        return callback(null, template(that.data))
      } else {
        layout = Handlebars.compile(results.layout)
        return callback(null, layout({ body: template(that.data) }))
      }
    })
  },
})
